#ifndef PROPELLERLOADER_H
#define PROPELLERLOADER_H

#include "libs/QSerialDevice/qserialdevice/abstractserial.h"

#include <QIODevice>
#include <QProgressBar>

class PropellerLoader : public QObject
{
    Q_OBJECT
public:
    PropellerLoader();
    PropellerLoader(AbstractSerial *device, QProgressBar* progress);

    enum LoaderResult {
        LoaderOK = 0,
        LoaderInvalidFile,
        LoaderCommError
    };

    LoaderResult updateFirmware(QByteArray data, bool useReset);

private:
    AbstractSerial *device;
    uint8_t LFSR;

    void sendCalibration();
    uint8_t iterateLFSR();
    void sendByte(uint8_t);
    void sendLong(uint32_t);
    void sendBytes(char*, uint16_t);
    bool getReply(char*c);
    void advance(int);

    QProgressBar* progress;
    int progressMax;
    int progressValue;


};

class PropellerPacker
{
public:
    PropellerPacker();
    void pack(uint8_t bit);
    QByteArray& finalize();
private:
    uint16_t bits;
    int bitsUsed;
    QByteArray bytes;
};

#endif // PROPELLERLOADER_H
